/*
 * Messages.h
 *
 *  Created on: Jan 31, 2024
 *      Author: mrcode
 */

#ifndef MODULES_CAN_MESSAGES_H_
#define MODULES_CAN_MESSAGES_H_

#include <cstdint>

#include "by_nav_x2_can_v0.hpp"

struct physical_control_request1_t{
    uint8_t ipc_target_motor_en;
    uint8_t ipc_target_gear;
    uint8_t ipc_target_mode;
    uint8_t ipc_life_signal;
    float ipc_target_speed;
    uint8_t ipc_target_spd_valid;
    float ipc_target_brk_press;
	float ipc_target_angle;
    uint8_t ipc_target_steering_en;
    float ipc_target_torque;
    uint8_t ipc_torque_rpm_mode;
    uint8_t ipc_turn_light;
    uint8_t ipc_target_spd_mode;
	uint64_t timestamp_s;
    uint64_t timestamp_ns;
    uint8_t crc8;
};



namespace Can {

class Messages {

public:
	~Messages();

	//deleting copy constructor
	Messages(const Messages&) = delete;

	static Messages* get_instance();

	CAN2SWC& get_all_messages();


private:
	static Messages* m_instance_ptr;

	CAN2SWC m_all_messages;

	Messages();
};

} /* namespace Can */

#endif /* MODULES_CAN_MESSAGES_H_ */
